-- compteur tristate
-- cnt_tri1.vhd

library ieee ;
use ieee.std_logic_1164.all, ieee.numeric_std.all ;
-- type UNSIGNED is array (NATURAL range <>) of STD_LOGIC;

entity cnt_tri is
   generic(taille : natural := 10) ;
   port( hor : in std_ulogic ;
         cde : in std_logic_vector(1 to 3);
         compte : out unsigned(taille-1 downto 0) ) ;
   alias raz : std_logic is cde(1) ;
   alias en  : std_logic is cde(2) ;
   alias oe  : std_logic is cde(3) ;
end cnt_tri ;

architecture ieee_lib of cnt_tri is
   signal etat : unsigned(taille-1 downto 0) ;
begin
   compte <= etat when oe = '1' else (others => 'Z') ;
   compteur : process
   begin
      wait until rising_edge(hor) ;
      if raz = '1' then
         etat <= (others => '0') ;
      elsif en = '1' then
         etat <= etat + 1 ;
      end if ;
   end process compteur ;
end ieee_lib ;
