-- test bench : generateur de vecteur de test
-- genvect.vhd


library ieee ;
use ieee.std_logic_1164.all ;
use work.tbenchpg.all ;

entity genvect is
   generic(retard : time := 0 ns;
           taillevect : positive := 1;
           sequence : positive := 1 ) ;
   port (hor : in std_ulogic ;
         stop : in boolean := false ;
         start : in boolean := false ;
         testin : in vectable(1 to sequence,1 to taillevect) ;
         vectout : out std_logic_vector(1 to taillevect) ;
         finseq : out boolean) ;
end genvect ;

architecture boucle of genvect is
   signal advect : positive := 1 ;
begin
finseq <= advect = testin'high(1) ;
stimuli : process
   begin
   for i in testin'range(2) loop
      vectout(i) <= testin(advect,i) after retard ;
   end loop ;
   if not stop then
      if start then
         advect <= 1 ;
      elsif advect < testin'high then
         advect <= advect + 1 ;
      end if ;
   end if ;
   wait until rising_edge(hor) ;
end process stimuli ;
end boucle ;
