-- test bench : package
-- tbenchpg.vhd

library ieee ;
use ieee.std_logic_1164.all ;

package tbenchpg is

type vectable is array(positive range <>, positive range <>) of std_logic ;

component genhor is
   port( tck : in time := 100 ns ;
         hor : buffer std_ulogic := '0') ;
end component genhor ;

component genvect is
   generic(retard : time := 0 ns;
           taillevect : positive := 1;
           sequence : positive := 1 ) ;
   port (hor : in std_ulogic ;
         stop : in boolean := false ;
         start : in boolean := false ;
         testin : in vectable(1 to sequence,1 to taillevect) ;
         vectout : out std_logic_vector(1 to taillevect) ;
         finseq : out boolean) ;
end component genvect ;

component cobaye is
   port (hor : in std_ulogic ;
         commande : in std_logic_vector ;
         sorties : out std_logic_vector ) ;
end component cobaye ;

function tovectelem(e : in std_logic) return std_logic_vector ;

function toelem(e : in std_logic_vector(1 to 1)) return std_logic ;

end tbenchpg ;

package body tbenchpg is
   function tovectelem(e : in std_logic) return std_logic_vector is
      variable solo : std_logic_vector(1 to 1) ;
   begin
      solo(1) := e ;
      return solo ;
   end function tovectelem ;
   function toelem(e : in std_logic_vector(1 to 1)) return std_logic is
      variable solo : std_logic ;
   begin
      solo := e(1) ;
      return solo ;
   end function toelem ;

end package body tbenchpg ;
