-- test bench : test direct, sans configuration, compteur
-- test_cpt.vhd

library ieee ;
use ieee.std_logic_1164.all,ieee.numeric_std.all ;
use work.tbenchpg.all ;

entity test_cpt is
end test_cpt ;

architecture struct of test_cpt is
   constant retard : time := 0 ns ;
   constant tck : time := 20 ns ;
   constant tailleresult : positive := 3 ;
   constant test : vectable := (       -- fonction sortie
                                "101", -- raz      active
                                "001", -- mmoire  active
                                "011", -- comptage active
                                "011", -- comptage active
                                "011", -- comptage active
                                "001", -- mmoire  active
                                "011", -- comptage active
                                "010", -- comptage inactive 
                                "011", -- comptage active
                                "111", -- raz      active
                                "011"  -- comptage active
                               ) ;
   constant taillevect : positive := test'high(2) ;
   constant sequence : positive := test'high(1) ;
   signal vectcom : std_logic_vector(1 to taillevect) ;
   signal testdata : vectable(1 to sequence,1 to taillevect) := test ;
   signal resultat : unsigned(tailleresult-1 downto 0) ;
   signal hor : std_ulogic ;
   signal stop : boolean := false ;
   signal roule : boolean ;

begin
   dut : entity
      work.compteur_tri(ieee_lib)
         generic map (taille => tailleresult)
         port map ( hor => hor,
                    raz => vectcom(1),
                    en => vectcom(2),
                    oe => vectcom(3), 
                    compte => resultat
                   ) ;

   horloge : genhor  port map (tck => tck,
                               hor => hor) ;
   gene : genvect
      generic map (retard => retard,
                   taillevect => taillevect,
                   sequence => sequence)
      port map ( hor => hor,
                 stop => stop,
                 start => roule,
                 testin => testdata,
                 vectout => vectcom,
                 finseq => roule) ;

end struct ;
